/*! 
    \file event_handler.h
    \brief Definition of the EventHandler
    
*/

#ifndef _EVENT_HANDLER_H
#define _EVENT_HANDLER_H

#include "base_object.h"
#include "key_mapper.h"
#include "event_def.h"

class EventListener;


//! The one Event Handler from Orxonox
class EventHandler : public BaseObject {

 public:
  static EventHandler* getInstance(void);
  virtual ~EventHandler(void);

  void init();

  void setState(elState state);

  void subscribe(EventListener* el, elState state, int eventType);
  void unsubscribe(elState state, int eventType);
  void unsubscribe(EventListener* el, elState state = ES_ALL);

  void flush(elState state);

  void tick(float t);
  void process();

  void test();

 private:
  EventHandler(void);
 

 private:
  static EventHandler* singletonRef;
  EventListener*** listeners;                         //!< a list of registered listeners
  elState state;
  KeyMapper* keyMapper;
};

#endif /* _EVENT_HANDLER_H */
